/** A interface do catlogo telefnico.
 *  @author Koffman & Wolfgang
*/

public interface CatalogoTelefonico {

  /** Carrega o arquivo de dados que contm o catlogo ou
      estabelece uma conexo com a fonte de dados.
      @param nomeDaFonte O nome do arquivo (fonte de dados) que 
                         contm as entradas do catlogo telefnico.
   */
  void carregaDados(String nomeDaFonte);

  /** Procura uma entrada.
        @param nome O nome da pessoa a ser procurado
        @return O nmero ou null, se nome no existir no catlogo
   */
  String procuraEntrada(String nome);

  /** Adiciona uma entrada ou altera uma entrada existente.
        @param nome O nome da pessoa que est sendo adicionado ou alterado
        @param numero O novo nmero a ser atribudo
        @return O nmero anterior ou, no caso de uma entrada nova, null
   */
  String adicionaOuAlteraEntrada(String nome, String numero);

  /** Remove uma entrada do catlogo.
        @param nome O nome da pessoa a ser removido
        @return O nmero atual. Se no existir no catlogo, null 
                ser retornado.
   */
  String removeEntrada(String nome);

  /** Mtodo para gravao do catlogo.
      pr: O catlogo foi carregado com dados.
      ps: O contedo do catlogo  gravado novamente no arquivo na 
           forma de pares nome-nmero em linhas adjacentes, 
           modificado  redefinida com false.
   */
  void salva();
}
